Subject: bug#59214: closed (Re: bug#59214: [PATCH] Alternate rust-analyzer command added)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 18 Nov 2022 08:44:02 +0000

Your bug report

#59214: [PATCH] Alternate rust-analyzer command added

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
59214: https://debbugs.gnu.org/cgi/bugreport.cgi?bug=59214
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#59214: [PATCH] Alternate rust-analyzer command added
From: João Távora <[email-masked]>
To: Eli Zaretskii <[email-masked]>
Cc: [email-masked], [email-masked], Pankaj Jangid <[email-masked]>
Date: Fri, 18 Nov 2022 08:44:35 +0000
List-Id: <debbugs-submit.debbugs.gnu.org>

No, I think we came to the conclusion that there's nothing
to be done.  "rust-analyzer" is a good current candidate
for an executable and it will be an even better candidate
soon, as the rustup folks have announced, because they
too will soon providel an executable in PATH named exactly
like that.

So I'm closing this bug.
João

On Fri, Nov 18, 2022 at 8:29 AM Eli Zaretskii <[email-masked]> wrote:

> > From: Pankaj Jangid <[email-masked]>
> > Cc: Eli Zaretskii <[email-masked]>,  "M. Ian Graham"
> >  <[email-masked]>,  [email-masked]
> > Date: Fri, 18 Nov 2022 10:43:02 +0530
> >
> > João Távora <[email-masked]> writes:
> >
> > >> FWIW, I think Rust is too crazy for us to follow its daily changes and
> > >> offer support for its server OOTB in eglot-server-programs.  Emacs is
> > >> not equipped to follow such frequent and radical changes.  If we want
> > >> to make this seamless for users of Rust, we should provide a special
> > >> command to update eglot-server-programs with whatever it is the latest
> > >> Rust fashion.  Or maybe we should even leave that to Rust mode.
> > >>
> > >
> > > Yes, indeed, my thoughts exactly, especially this last bit.
> > >
> >
> > Agree.
> >
> > And thank you, Ian, for bringing up the counter thoughts in the
> > discussion. It was an eye opener for me. I was thinking `rustup' is the
> > only way to use `rust'.
>
> So what's the bottom line here?  Do we need to make any change in
> eglot.el, and if so, what change is that?
>

-- 
João Távora

Subject: [PATCH] Alternate rust-analyzer command added
From: Pankaj Jangid <[email-masked]>
To: [email-masked]
Date: Sat, 12 Nov 2022 17:23:19 +0530
List-Id: <debbugs-submit.debbugs.gnu.org>

* lisp/progmodes/eglot.el (eglot-server-programs): There are two
ways to run rust-analyzer. After adding the rustup component,
users can add rust-analyzer to path and run rust-analyzer directly
or they may run ``rustup run stable rust-analyzer'' command. This
revision adds the 2nd command to the list of server programs.
---
 lisp/progmodes/eglot.el | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

diff --git a/lisp/progmodes/eglot.el b/lisp/progmodes/eglot.el
index 63ebbe6cab..f54c2d2c3a 100644
--- a/lisp/progmodes/eglot.el
+++ b/lisp/progmodes/eglot.el
@@ -181,7 +181,7 @@ eglot-alternatives
                       when probe return (cons probe args)
                       finally (funcall err)))))))
 
-(defvar eglot-server-programs `((rust-mode . ,(eglot-alternatives '("rust-analyzer" "rls")))
+(defvar eglot-server-programs `((rust-mode . ,(eglot-alternatives '("rust-analyzer" ("rustup" "run" "stable" "rust-analyzer") "rls")))
                                 (cmake-mode . ("cmake-language-server"))
                                 (vimrc-mode . ("vim-language-server" "--stdio"))
                                 (python-mode
-- 
2.30.2